//
//   Convert.h : Header file for class CConvert
//
//  CubeShow Version 1.0 Copyright (c) 2002
//  Ziff Davis Media, Inc.
//  All rights reserved.
//  First Published in PC Magazine, US Edition, July 2000
//
//  Author : Mark Nelson
//  Date   : May 23, 2002
//
//  Description
//
//  This class is responsible for performing the conversion/downsizing
//  step when the user selects a new directory of image files. Each file is
//  read into a DC, resized to be around 256x256, and saved to a BMP file in
//  the Image Cache folder under the app folder. The hard work of loading
//  the image is done by the OleLoadPicture function, which loads a JPG
//  into an IPicture interface. Writing the BMP file is donw using code
//  that was cut directly out of Microsoft's MSDN web site.
//

#if !defined(AFX_CONVERT_H__9F041F00_BB32_4F34_8928_76951D586322__INCLUDED_)
#define AFX_CONVERT_H__9F041F00_BB32_4F34_8928_76951D586322__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CConvert dialog

class CConvert : public CDialog
{
public:
    CConvert(CWnd* pParent = NULL);   // standard constructor
    virtual ~CConvert();

    void SetConvert( bool convert );
    void SetTargetBmpSize( int count ){ m_TargetBmpSize = count; }
    int GetInputCount();
    bool Convert( CString &inputFile, CString &outputFile );
    const CString GetOutputFileName( int i ){ return m_OutputFiles[ i ]; }
    int GetProcessedCount();
    void SetSourcePath( CString path );

    afx_msg void OnUser( WPARAM, LPARAM );

    static UINT Converter( LPVOID lParam );

    // Dialog Data
    //{{AFX_DATA(CConvert)
    enum { IDD = IDD_CONVERT };
    CButton          m_CancelButton;
    CButton          m_AbortButton;
    CProgressCtrl    m_Progress;
    CButton          m_OkButton;
    //}}AFX_DATA


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CConvert)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

// Implementation
protected:
    int m_TargetBmpSize;
    bool m_bConvert;
    list<CString> m_InputFiles;
    deque<CString> m_OutputFiles;
    CString sourcePath;
    CWinThread * converterThread;
    HANDLE m_hConverterThread;
    bool m_KillThread;

    // Generated message map functions
    //{{AFX_MSG(CConvert)
    virtual BOOL OnInitDialog();
    afx_msg void OnAbort();
    virtual void OnOK();
    afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
    virtual void OnCancel();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CONVERT_H__9F041F00_BB32_4F34_8928_76951D586322__INCLUDED_)
