//
//   CubeShowConfigDialog.h : Declaration file for class CCubeShowConfigDialog
//
//  CubeShow Version 1.0 Copyright (c) 2002
//  Ziff Davis Media, Inc.
//  All rights reserved.
//  First Published in PC Magazine, US Edition, July 2000
//
//  Author : Mark Nelson
//  Date   : May 23, 2002
//
//  Description
//
//  This class is derived from CDialog, and does all the work required to present
//  the user the configuration dialog. It is normally presented to the user after
//  pressing the Settings button in the Display Properties dialog when on the Screen
//  Saver tab. All the options displayed in this dialog reflect settings seen in
//  CubeShow.ini. However, this dialog relies on whoever invokes it to set up all
//  the values that are read from the INI file, and expects the same caller to store
//  all the new values. One exception: the list of image files and their count are
//  managed directly here.
//
#if !defined(AFX_CUBESHOWCONFIGDIALOG_H__97CA76B9_52B6_489A_A89C_DB985EBDB207__INCLUDED_)
#define AFX_CUBESHOWCONFIGDIALOG_H__97CA76B9_52B6_489A_A89C_DB985EBDB207__INCLUDED_


/////////////////////////////////////////////////////////////////////////////
// CCubeShowConfigDialog dialog

class CCubeShowConfigDialog : public CDialog
{
public:
    virtual BOOL PreTranslateMessage(MSG* pMsg);
    CString m_PicturePath;
    int m_KeepUpright;
    int m_SliderSpinZ;
    int m_SliderSpinY;
    int m_SliderSpinX;
    int m_SliderSpeedZ;
    int m_SliderSpeedY;
    int m_SliderSpeedX;
    int m_SliderCubeSize;
    bool m_ForceConvert;
    CCubeShowConfigDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
    //{{AFX_DATA(CCubeShowConfigDialog)
    enum { IDD = IDD_CONFIG_DIALOG };
    CButton    m_OkButton;
    //}}AFX_DATA
// Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CCubeShowConfigDialog)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

// Implementation
protected:
    void DeleteImageCacheFiles();
    CToolTipCtrl m_tooltip;
    static int CALLBACK BrowseCallbackProc( HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData );

    // Generated message map functions
    //{{AFX_MSG(CCubeShowConfigDialog)
    virtual BOOL OnInitDialog();
    afx_msg void OnDestroy();
    afx_msg void OnSelectDirectoryButton();
    afx_msg void OnAbout();
    afx_msg void OnChangePicturePath();
    virtual void OnOK();
    afx_msg void OnHelp();
	afx_msg void OnAdvanced();
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CUBESHOWCONFIGDIALOG_H__97CA76B9_52B6_489A_A89C_DB985EBDB207__INCLUDED_)
