//
//   CubeShowWnd.h : Declarations file for class CCubeShowWnd
//
//  CubeShow Version 1.0 Copyright (c) 2002
//  Ziff Davis Media, Inc.
//  All rights reserved.
//  First Published in PC Magazine, US Edition, July 2000
//
//  Author : Mark Nelson
//  Date   : May 23, 2002
//
//  Description
//
//  The class that actually implements the window used in the screen saver
//  is class CDrawWnd. When the screen saver is invoked in thumbnail preview
//  mode CDrawWnd writes to a parent window, which is normally the Display
//  Properties dialog. However, in Full Screen mode and Test mode, the
//  Screen Saver has to supply the parent window itself. That's the purpose of
//  this class. In full screen mode, the Create() method of this class is called
//  to create a topmost full screen window to draw on. In test mode, the
//  CreateTest() method is called to create a resizable window. Once the window
//  is created, the parent class, CDrawWnd can be relied on to do most of the
//  interesting work behind actually drawing to the screen.
//
//  Much of the code in the CCubeShowApp class was posted on CodeGuru by 
//  chensu at the following URL: http://www.codeguru.com/misc/scrfrmwk.shtml.
//  CodeGuru allows unrestricted use of the code samples on their web
//  site, and is well worth a visit at http://www.codeguru.com.
//

class CCubeShowWnd : public CDrawWnd
{
// Construction
public:
    CCubeShowWnd();

// Attributes

// Operations
public:
    BOOL Create();
    BOOL CreateTest();

// Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CCubeShowWnd)
    //}}AFX_VIRTUAL

// Implementation
public:
    virtual ~CCubeShowWnd();

    // Generated message map functions
protected:
    //{{AFX_MSG(CCubeShowWnd)
    afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnDestroy();
    afx_msg BOOL OnSetCursor(CWnd *pWnd, UINT nHitTest, UINT nMessage);
    afx_msg BOOL OnNcActivate(BOOL bActive);
    afx_msg void OnActivate(UINT nState, CWnd *pWndOther, BOOL bMinimized);
    afx_msg void OnActivateApp(BOOL bActive, HTASK hTask);
    afx_msg void OnMouseMove(UINT nFlags, CPoint point);
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
    afx_msg void OnSysKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
    afx_msg void OnClose();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

protected:
    BOOL m_bIsDialogActive;    // if Verify Password dialog box is active
    BOOL m_bReallyClose;       

    CPoint m_ptInitCursorPos;  // cursor's position in screen coordinates
    DWORD m_dwInitTime;        // initial time in milliseconds

    DWORD m_dwMouseThreshold;  // Mouse Threshold in pixels

    void CloseSaverWindow( const char *reason );
    BOOL ExceedThreshold();
    BOOL VerifyPassword( HWND hWndParent );
};

/////////////////////////////////////////////////////////////////////////////
