//
//   DrawWnd.h : Declaration file for class CDrawWnd
//
//  CubeShow Version 1.0 Copyright (c) 2002
//  Ziff Davis Media, Inc.
//  All rights reserved.
//  First Published in PC Magazine, US Edition, July 2000
//
//  Author : Mark Nelson
//  Date   : May 23, 2002
//
//  Description
//
//  This class works hand in hand with class CCubeShowWnd to display the screen saver.
//  CCubeShowWnd provides most of the behavior for the class, handling key presses,
//  mouse movement, and messages from the O/S. This is the base class, and it basically
//  only does a few important things: it creates the window in one of two different
//  ways, and actually does the cube drawing on a timer.
//
//

class CDrawWnd : public CWnd
{
public:
    CDrawWnd(BOOL bAutoDelete = TRUE);

// Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CDrawWnd)
    public:
    virtual BOOL Create(DWORD dwExStyle, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT &rect, CWnd *pWndParent, UINT nID = 0);
    protected:
    virtual void PostNcDestroy();
    //}}AFX_VIRTUAL

// Implementation
public:
    void CreateGraphicsObject(DWORD dwExStyle );
    int count;
    DXGraphics * pGraphics;
    virtual ~CDrawWnd();

protected:
    BOOL m_bAutoDelete;

    // Generated message map functions
protected:
    DWORD m_dwExStyle;
    UINT mmTimerId;
    enum { NO_PAUSE, REQUEST_PAUSE, ACK_PAUSE } m_Pause;
    DWORD startTime;
    static void _stdcall mmTimerProc(UINT uTimerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2);
    bool TimerWorker();
    //{{AFX_MSG(CDrawWnd)
    afx_msg void OnPaint();
    afx_msg void OnTimer(UINT nIDEvent);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

